﻿;console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('mb')<0){}};const SVG_NS = "http://www.w3.org/2000/svg";
let m = {};
let groups = [];
let draggable = null;
let rotatable = null;
let theGroup = null;

let type = ["independent", "dependent"];

class Point {
  constructor(p, pos) {
    this.abs = p;
    (this.rel = {
      x: this.abs.x - pos.x,
      y: this.abs.y - pos.y
    }),
      (this.Angle = Math.atan2(this.rel.y, this.rel.x));
    this.angle = Math.atan2(this.rel.y, this.rel.x);
    this.getDist();
  }
  getAngle() {
    this.angle = Math.atan2(this.rel.y, this.rel.x);
  }

  getDist() {
    this.dist = Math.sqrt(this.rel.x * this.rel.x + this.rel.y * this.rel.y);
  }

  update(pos) {
    (this.rel = {
      x: this.abs.x - pos.x,
      y: this.abs.y - pos.y
    }),
      this.getAngle();
    this.getDist();
  }
}

class Group {
  // builds a group of a point and 2 control points
  constructor(cp2, pos, cp1) {
    //
    // cp2 ◉----●----◉ cp1
    //         pos

    this.pos = pos;
    this.cp1 = new Point(cp1, pos);
    this.cp2 = new Point(cp2, pos);

    this.n = 0;
    this.type = this.n % 2 == 0 ? "independent" : "dependent";
    this.draw();
    this.addEvents();
  } //constructor

  draw() {
    // call this only once from the constructor.
    // draw the group
    this.eG = drawSVGelmt(
      { transform: `translate(${this.pos.x},${this.pos.y})` },
      "g",
      svg
    );
    
    this.eG.setAttribute("class",this.type)

    //draw the connector
    this.eConnector = drawSVGelmt(
      {
        points: `${this.cp2.rel.x},${this.cp2.rel.y}
                 0,0
                 ${this.cp1.rel.x},${this.cp1.rel.y}`
      },
      "polyline",
      this.eG
    );

    // draw the element for the bézier point
    this.ePoint = drawSVGelmt({ r: 4 }, "circle", this.eG);

    //draw the element for the control point cp2
    this.eCp2 = drawSVGelmt(
      { r: 2, cx: this.cp2.rel.x, cy: this.cp2.rel.y, class: "cp" },
      "circle",
      this.eG
    );

    //draw the element for the control point cp1
    this.eCp1 = drawSVGelmt(
      { r: 2, cx: this.cp1.rel.x, cy: this.cp1.rel.y, class: "cp" },
      "circle",
      this.eG
    );
  }
  
  
  reverseUpdate(){
    this.cp1.rel.x = this.cp1.abs.x - this.pos.x;
    this.cp1.rel.y = this.cp1.abs.y - this.pos.y;
    this.cp2.rel.x = this.cp2.abs.x - this.pos.x;
    this.cp2.rel.y = this.cp2.abs.y - this.pos.y;
  }

  update() {
    this.cp1.abs.x = this.cp1.rel.x + this.pos.x;
    this.cp1.abs.y = this.cp1.rel.y + this.pos.y;
    this.cp2.abs.x = this.cp2.rel.x + this.pos.x;
    this.cp2.abs.y = this.cp2.rel.y + this.pos.y;

    this.eG.setAttributeNS(
      null,
      "transform",
      `translate(${this.pos.x},${this.pos.y})`
    );

    //update cp1
    this.eCp1.setAttributeNS(null, "cx", this.cp1.rel.x);
    this.eCp1.setAttributeNS(null, "cy", this.cp1.rel.y);
    //update cp2
    this.eCp2.setAttributeNS(null, "cx", this.cp2.rel.x);
    this.eCp2.setAttributeNS(null, "cy", this.cp2.rel.y);
    //update connector
    let attrPoints = `${this.cp2.rel.x},${this.cp2.rel.y}
                      0,0
                      ${this.cp1.rel.x},${this.cp1.rel.y}`;

    this.eConnector.setAttributeNS(null, "points", attrPoints);
    
    
  }

  addEvents() {
    this.ePoint.addEventListener("mousedown", e => {
      draggable = true;
      theGroup = this;
    });
    this.ePoint.addEventListener("dblclick", e => {
      this.n++;
      this.type = this.n % 2 == 0 ? "independent" : "dependent";
      
      this.eG.setAttribute("class",this.type)
      
      
      this.cp1.Angle = this.cp1.angle;
      this.cp2.Angle = this.cp2.angle;

      console.log(this.n,this.type);
    });
    this.eCp1.addEventListener("mousedown", e => {
      rotatable = 1;
      theGroup = this;
    });
    this.eCp2.addEventListener("mousedown", e => {
      rotatable = 2;
      theGroup = this;
    });
  }
}

//the first 3 points
groups.push(
  new Group({ x: 100, y: 200 }, { x: 150, y: 150 }, { x: 200, y: 100 })
);

groups.push(
  new Group({ x: 300, y: 100 }, { x: 370, y: 150 }, { x: 410, y: 180 })
);

groups.push(
  new Group({ x: 310, y: 350 }, { x: 180, y: 350 }, { x: 100, y: 350 })
);

function drawPath() {
  // a function to draw the path using the absolutes values 
  let last = groups[groups.length - 1];
  let d = `M${last.pos.x},${last.pos.y}C${last.cp1.abs.x},${last.cp1.abs.y} `;
  //
  // cp2 ◉----●----◉ cp1
  //         pos
  for (let i = 0; i < groups.length - 1; i++) {
    let g = groups[i];
    d += `${g.cp2.abs.x},${g.cp2.abs.y} ${g.pos.x},${g.pos.y} C${g.cp1.abs.x},${
      g.cp1.abs.y
    } `;
  }

  d += `${last.cp2.abs.x},${last.cp2.abs.y} ${last.pos.x},${last.pos.y} z`;
  
  thePath.setAttributeNS(null, "d", d);
  console.clear();
  console.log(d)
  
}

drawPath();



svg.addEventListener("mouseup", () => {
  draggable = false;
  rotatable = false;
});

svg.addEventListener("mousemove", e => {
  if (draggable || rotatable) {
    m = getMousePositionSVG(e); 

    if (draggable) {
      theGroup.pos.x = m.x;
      theGroup.pos.y = m.y;

      theGroup.update();
    }

    if (rotatable) {
      
      
      if (theGroup.type == "independent") {
        // the 2 control points are moving independently one of each other
        // rotatable = 1 || 2
        // rotatable == 1 if I move the cp1; rotatable == 2 if I move the cp2;
          theGroup[`cp${rotatable}`].abs.x = m.x;
          theGroup[`cp${rotatable}`].abs.y = m.y;

          theGroup[`cp${rotatable}`].update(theGroup.pos);
          theGroup.update();
        
      } else if (theGroup.type == "dependent") {
        // the 2 control points moviment is correlated
        // rotatable = 1 || 2
        // rotatable == 1 if I move the cp1; rotatable == 2 if I move the cp2;
        
        // the other control point
        let theOther = rotatable % 2 + 1; // 2 || 1

        theGroup[`cp${rotatable}`].abs.x = m.x;
        theGroup[`cp${rotatable}`].abs.y = m.y;

        theGroup[`cp${rotatable}`].update(theGroup.pos);

        let deltaAngle =
          theGroup[`cp${rotatable}`].angle -
          theGroup[`cp${rotatable}`].Angle +
          theGroup[`cp${theOther}`].Angle;

        theGroup[`cp${theOther}`].abs.x =
          theGroup.pos.x +
          theGroup[`cp${theOther}`].dist * Math.cos(deltaAngle);
        theGroup[`cp${theOther}`].abs.y =
          theGroup.pos.y +
          theGroup[`cp${theOther}`].dist * Math.sin(deltaAngle);

        theGroup[`cp${theOther}`].update(theGroup.pos);

        theGroup.update();
      } //"dependent"
    }

    drawPath();
  } //if (draggable || rotatable)
});

thePath.addEventListener("click", addPoint);

function addPoint(e) {
  // a function to add a new point to the path
  let m = getMousePositionSVG(e);
  //the total length of the path in this moment
  let pathLength = thePath.getTotalLength();
  // divide the path in n segments (precision)
  let precision = 100;
  //the length of each segment
  let division = pathLength / precision;
  
  // get the position of the new point on the path
  let pathLengthForThePoint = getLengthForPoint(m,thePath);
  //the coords of the point are the mouse coords
  let thePoint = {x:m.x,y:m.y} 
  //generate a new group. The control points will be recalculated latter
  let newGroup = new Group(
      { x: thePoint.x, y: thePoint.y },
      { x: thePoint.x, y: thePoint.y },
      { x: thePoint.x, y: thePoint.y }
    )
  //set the pathLengthForThePoint property for the new group
  newGroup.pathLengthForThePoint = pathLengthForThePoint;
  //set the pathLengthForThePoint property for every group in the groups array
  groups.map(g=>{
    g.pathLengthForThePoint = getLengthForPoint(g.pos,thePath);
  })
  
  //push the new group in the groups array
  groups.push(
    newGroup
  );
  
  //sort the groups array by the pathLengthForThePoint property
  //otherwise the newGroup would be the last point on the array
  groups.sort((a, b) => (a.pathLengthForThePoint > b.pathLengthForThePoint) ? 1 : -1)
  //add an index to every group
  // I'l be using this index latter to recalculate the control points positions for:
  // the new added group
  // the previous group
  // the next group
  groups.map((g,i) => {g.index = i})
  
 
  ///////////////////////
    let index = newGroup.index;
    // the new added group 
    let g = groups[index];
    // the previous group
    let prev = (index-1 >= 0) ? groups[index-1] : groups[groups.length-1];
    // the next group
    let next = (index+1 <= groups.length-1) ? groups[index+1] : groups[0];
    // the points for the sub path controlled by the new added group
    let points = [
      [prev.pos.x,prev.pos.y],
      [prev.cp1.abs.x,prev.cp1.abs.y],
      [next.cp2.abs.x,next.cp2.abs.y],
      [next.pos.x,next.pos.y]
    ];
 
    // the d attribute for the sub path 
    let subPathD = `M${points[0][0]},${points[0][1]}
                    C${points[1][0]},${points[1][1]} 
                     ${points[2][0]},${points[2][1]}
                     ${points[3][0]},${points[3][1]}`;
  
    // creating a new path that won't be attached to the DOM
    // it's just for calculating the length of the sub path
    let subPath = document.createElementNS(SVG_NS,"path");
    subPath.setAttributeNS(null,"d",subPathD);
    //the length of the sub path
    let subPathLength = subPath.getTotalLength();
    //the position of the new point on the sub path
    let theLengthForPoint = getLengthForPoint(thePoint,subPath);
    // a number between 0 and 1
    let t = theLengthForPoint / subPathLength; // 0 < t < 1
    // get the helper points array: 
    // the new control points for the point, previous point and next point
    let helperPoints = getCPoints(t,points);
  
   
    // remove the group element
    svg.removeChild(newGroup.eG);
    //replace the group object
    groups[index] = new Group(
      { x: helperPoints[3][0], y: helperPoints[3][1] },
      { x: thePoint.x, y: thePoint.y },
      { x: helperPoints[4][0], y: helperPoints[4][1] }
    )
    //the new cp1 for the previous point
    prev.cp1.abs.x = helperPoints[0][0];
    prev.cp1.abs.y = helperPoints[0][1];
    //the new cp1 for the next point
    next.cp2.abs.x = helperPoints[2][0];
    next.cp2.abs.y = helperPoints[2][1];
    
    //calculate the relatives values from the absolutes values
    //prev.reverseUpdate();
    //next.reverseUpdate();
  //////////////////////
     groups.forEach(g=>{g.reverseUpdate();g.update()})
  
  // a function used to aproximate the length at point
  function getLengthForPoint(m,thePath){
    let theRecord = pathLength;
    let theSegment;
    for (let i = 0; i < precision; i++) {
    let p = thePath.getPointAtLength(i * division);
    let theDistance = dist(m, p);
    if (theDistance < theRecord) {
      theSegment = i;
      theRecord = theDistance;
    }
  }
  return(theSegment * division);
  }
  
  
  
  drawPath();
} ///

// helpers

function getCPoints(t,points) {//get the control points for the new group
  let helperPoints = [];

  // helper points 0,1,2
  for (let i = 1; i < points.length; i++) {
    //points.length must be 4 !!!
    let p = lerp(points[i - 1], points[i], t);
    
    helperPoints.push(p);
  }

  // helper points 3,4
  helperPoints.push(lerp(helperPoints[0], helperPoints[1], t));
  helperPoints.push(lerp(helperPoints[1], helperPoints[2], t));
  // helper point 5 is where the first Bézier ends and where the second Bézier begins
  helperPoints.push(lerp(helperPoints[3], helperPoints[4], t));

  return helperPoints;
}

function lerp(A, B, t) {
  return [
    (B[0] - A[0]) * t + A[0], // the x coordinate
    (B[1] - A[1]) * t + A[1]  // the y coordinate
  ];
}




function drawSVGelmt(o, tag, parent) {
  var elmt = document.createElementNS(SVG_NS, tag);
  for (var name in o) {
    if (o.hasOwnProperty(name)) {
      elmt.setAttributeNS(null, name, o[name]);
    }
  }
  parent.appendChild(elmt);
  return elmt;
}

function updateSVGelmt(o, element) {
  for (var name in o) {
    if (o.hasOwnProperty(name)) {
      element.setAttributeNS(null, name, o[name]);
    }
  }
}

function getMousePositionSVG(event) {
  var point = svg.createSVGPoint();
  point.x = event.clientX;
  point.y = event.clientY;
  point = point.matrixTransform(svg.getScreenCTM().inverse());
  return point;
}

function dist(p1, p2) {
  let dx = p2.x - p1.x;
  let dy = p2.y - p1.y;
  return Math.sqrt(dx * dx + dy * dy);
};console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('mb')<0){}};